-- hds header_start
--
-- VHDL Architecture ADC_VFE_Module.SROUT_reg.rtl
--
-- Created:
--          by - Osman Zorba.UNKNOWN (HEPPC185)
--          at - 16:33:41 05/10/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.all;



ENTITY SROUT_reg IS
   PORT( 
      CLK40D     : IN     std_logic;
      CONV_END   : IN     std_logic;
      CS         : IN     std_logic;
      RESET      : IN     std_logic;
      ADC_INFO1  : IN     std_logic_vector (4 DOWNTO 0);
      ADC_INFO2  : IN     std_logic_vector (4 DOWNTO 0);
      ADC_INFO3  : IN     std_logic_vector (4 DOWNTO 0);
      ADC_INFO4  : IN     std_logic_vector (4 DOWNTO 0);
      ADC_INFO5  : IN     std_logic_vector (4 DOWNTO 0);
      ADC_INFO6  : IN     std_logic_vector (4 DOWNTO 0);
      TOP_SROUT  : IN     std_logic;
      BOT_SROUT  : IN     std_logic;
      DATA_VALID : OUT    std_logic;
      DA_OUT     : OUT    std_logic_vector (31 DOWNTO 0)
   );

-- Declarations

END SROUT_reg ;

-- hds interface_end
ARCHITECTURE rtl OF SROUT_reg IS
signal tmp1: std_logic_vector (31 DOWNTO 0);
signal a, b, data_ready : std_logic;

BEGIN
process(CLK40D)

begin
 if (CLK40D'event and CLK40D='1') then

   if(RESET='1') then
      DA_OUT <= (others => 'Z');
	  tmp1 <= (others => '0');
	  a<= '0';
	  b <= '0';
	  data_ready <= '0';

   else
      a <= b;
      b <= CONV_END;

   if(a='0' and b='1') then
	    tmp1 (0) <= TOP_SROUT;
	    tmp1 (1) <= BOT_SROUT;
		tmp1 (6 downto 2) <= ADC_INFO5 ;
		tmp1 (11 downto 7) <= ADC_INFO3 ;
		tmp1 (16 downto 12) <= ADC_INFO1 ;
		tmp1 (21 downto 17) <= ADC_INFO6 ;
		tmp1 (26 downto 22) <= ADC_INFO4 ;
		tmp1 (31 downto 27) <= ADC_INFO2 ;
 	    data_ready <= '1';

   end if;

   if(CS='1') then
        DA_OUT <= tmp1;

   else
        DA_OUT <=(others => 'Z');

   end if;

   if(a='1' and b='0') then
    data_ready <='0';
   end if;
  end if;

  DATA_VALID <= data_ready;

 end if;

  end process;

END rtl;
