-- hds header_start
--
-- VHDL Architecture CERC_FE_FPGA.TRIG_dly_sigs.rtl
--
-- Created:
--          by - Osman Zorba.UNKNOWN (HEPPC185)
--          at - 15:18:59 10/01/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;


entity TRIG_dly_sigs is
   generic( 
      buswidth : natural := 16
   );
   port( 
      A0            : in     std_logic;
      A1            : in     std_logic;
      CLK160        : in     std_logic;
      clk40         : in     std_logic;
      CONFIG_SELECT : in     std_logic;
      RESET         : in     std_logic;
      SET_DATA      : in     std_logic_vector (31 downto 0);
      TRIGIN        : in     std_logic;
      rd            : in     std_logic;
      wr            : in     std_logic;
      HOLD_INT      : out    std_logic;
      HOLD_OUT      : out    std_logic;
      db_out        : out    std_logic_vector (31 downto 0)
   );

-- Declarations

end TRIG_dly_sigs ;


-- hds interface_end
ARCHITECTURE rtl_matt_orig OF TRIG_dly_sigs IS
signal      MCOUNT        :     std_logic_vector (31 DOWNTO 0);
signal      delaycount    :     std_logic_vector (31 DOWNTO 0);
signal      holdcount     :     std_logic_vector (31 DOWNTO 0);
signal      inthold       :     std_logic;
signal      tmp           :     std_logic_vector (31 DOWNTO 0);
signal      a             :     std_logic;
signal      b             :     std_logic;
signal      countenable1  :     std_logic;
signal      countenable   :     std_logic;

BEGIN
config: process (CLK160)

begin

  if(CLK160'event and CLK160='1') then
     if (RESET = '1') then
--        HOLD_OUT <= '0' ;
        countenable1 <= '0' ;
        delaycount <= (others => '0') ;
        holdcount <= (others => '0') ;
        inthold <='0' ;
        db_out <= (others => 'Z') ;
            
      elsif (CONFIG_SELECT ='1' and A0 = '0' and A1 = '0' and wr='1') then
           delaycount <=  SET_DATA ;
           countenable1 <= '0' ;

      elsif (CONFIG_SELECT ='1' and A0 = '1' and A1 = '0' and wr='1') then
           holdcount <= SET_DATA ;
           countenable1 <= '0' ;

      elsif (CONFIG_SELECT ='1' and A0 = '0' and A1 = '1' and wr='1') then
           inthold <= SET_DATA(0) ;
--           HOLD_OUT <= not SET_DATA(0) ;
           countenable1 <= '0' ;

      elsif (CONFIG_SELECT ='1' and A0 = '0' and A1 = '0' and rd='1') then
           db_out <=delaycount ;
           

      elsif (CONFIG_SELECT ='1' and A0 = '1' and A1 = '0' and rd='1') then
           db_out <=holdcount ;
          

      elsif (CONFIG_SELECT ='1' and A0 = '0' and A1 = '1' and rd='1') then
           db_out(0) <= inthold ;
         db_out(31 downto 1) <= (others => '0') ;
           
   elsif(CONFIG_SELECT = '0' or rd = '0') then 
    db_out <= (others => 'Z') ;
   end if;
 end if;

end process config;



TRIG_DELAY_LOGIC: process (CLK160)

begin

  if(clk40'event and clk40='1') then  -- *** slower clock
     if (RESET = '1') then
		HOLD_OUT <= '0' ;
        MCOUNT <= (others => '0');
        HOLD_INT <= '0' ;
        a<='0' ;
        b<='0' ;
		tmp <= (others => '0') ;
		countenable <= '0' ;

 -- Now we detect TRIGGER
 --
     elsif(countenable='0' and countenable1='0') then
       
       b <= a;     -- *** reversed pipeline order  
       a <=TRIGIN; -- = change from rising to falling edge detect (AND I think a->b is more intuitive)
       --a <= b;
       --b <=TRIGIN;

       if(a='0' and b='1') then -- New Trig ***FALLING*** Detected
            countenable <= '1' ;
            tmp <= delaycount ;
       
            MCOUNT <= ("00" & holdcount(31 downto 2)) ;  -- reset Master Counter
            -- *** Load with holdcount/4 to compensate for slower clock
            				
            --MCOUNT <= holdcount  -- reset Master Counter
      end if;

     elsif(countenable = '1') then
      if(tmp > "00000000000000000000000000000000") then  -- check if delay count is complete if not wait
         tmp <= (tmp - 1) ;
         HOLD_INT <= '0' ;
       HOLD_OUT <= not inthold ;

       else  -- delay count is complete set HOLD to '1'
           if(MCOUNT > "00000000000000000000000000000000") then
             MCOUNT <= (MCOUNT - 1) ;
             HOLD_INT <= '1' ;
             HOLD_OUT <= inthold ;
           else
             countenable <='0' ;
             HOLD_INT <= '0' ;
             HOLD_OUT <= not inthold ;

           end if;
       end if;

     end if; --countenable =1

  end if; -- CLK edge detect
end process TRIG_DELAY_LOGIC;


END rtl_matt_orig;
