-- hds header_start
--
-- VHDL Architecture CERC_FE_FPGA.VFE_sigs_out.rtl
--
-- Created:
--          by - Osman Zorba.UNKNOWN (HEPPC185)
--          at - 15:10:34 10/01/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;

ENTITY VFE_sigs_out IS
   PORT( 
      A0            : IN     std_logic;
      A1            : IN     std_logic;
      CLK           : IN     std_logic;
      CONFIG_SELECT : IN     std_logic;
      MCOUNT        : IN     std_logic_vector (31 DOWNTO 0);
      MLD           : IN     std_logic;
      RESET         : IN     std_logic;
      SET_DATA      : IN     std_logic_vector (31 DOWNTO 0);
      rd            : IN     std_logic;
      wr            : IN     std_logic;
      SIG_OUT       : OUT    std_logic;
      db_out        : OUT    std_logic_vector (31 DOWNTO 0)
   );

-- Declarations

END VFE_sigs_out ;

-- hds interface_end
ARCHITECTURE rtl OF VFE_sigs_out IS
signal      endcount_int   :     std_logic_vector (31 DOWNTO 0);
signal      mcount_int     :     std_logic_vector (31 DOWNTO 0);
signal      startcount_int :     std_logic_vector (31 DOWNTO 0);

BEGIN

config:process (CLK)

begin

 if (CLK'event and CLK='0') then
    if(RESET='1') then
      startcount_int <= (others =>'0') after 10 ps;
      endcount_int <= (others =>'0') after 10 ps;
      db_out <= (others => 'Z') after 10 ps;

    elsif(CONFIG_SELECT = '1' and A0='0' and A1='0' and wr='1') then
            startcount_int <= SET_DATA after 10 ps;

    elsif(CONFIG_SELECT = '1' and A0='1' and A1 = '0' and wr='1') then
            endcount_int <= SET_DATA after 10 ps;

    elsif(CONFIG_SELECT = '1' and A0='0' and A1='0' and rd='1') then
            db_out <= startcount_int after 10 ps;

    elsif(CONFIG_SELECT = '1' and A0='1' and A1 = '0' and rd='1') then
            db_out <= endcount_int after 10 ps;

   elsif(CONFIG_SELECT = '0' or rd = '0') then 
    db_out <= (others => 'Z') after 10 ps;
   end if;
 end if;
end process config;

first:process (CLK)

begin

 if (CLK'event and CLK='0') then
    if(RESET='1') then
      SIG_OUT <='0' after 10 ps;
	  mcount_int <=(others => '0') after 10 ps;


    elsif (MLD = '1') then
      mcount_int <= MCOUNT after 10 ps;

      if(mcount_int >= startcount_int and mcount_int <= endcount_int) then
          SIG_OUT <= '1' after 10 ps;   
      else
          SIG_OUT <= '0' after 10 ps;   
      end if;
    end if;

  end if;
  end process first;



END rtl;
