-- hds header_start
--
-- VHDL Architecture CALICE_lib.addr_decoder.rtl2
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:52:36 11/30/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity addr_decoder64 is
   port( 
      rst      : in     std_logic;
      clk      : in     std_logic;
      addr_i   : in     std_logic_vector (9 downto 0);
      ram_en_o : out    std_logic;
      en_i     : in     std_logic;
      reg_en_o : out    std_logic_vector (15 downto 0)
   );

-- Declarations

end addr_decoder64 ;

-- hds interface_end
architecture rtl of addr_decoder64 is
	signal reg_en: std_logic_vector(15 downto 0);
	signal ram_en: std_logic;

	
-------------------------------------------------------------------------------
-- MAIN CODE
-------------------------------------------------------------------------------
begin

	process(clk)
		variable iaddr : integer range 0 to 16#1FFF#; 
		
	begin
  	
  		iaddr := CONV_INTEGER( addr_i(9 downto 6) );
  		
  		if (clk'event and clk='1') then

  			if (rst='1') then
  				ram_en<='0';
  				reg_en<=(others => '0');

  		
	    	else

	   	 	-- defaults
  --				ram_en<='0';
  --				reg_en<=(others => '0');

				if (en_i = '1') then
			
		    		-- ram enable
	  				if (addr_i(9) = '1') then
	  					ram_en <= '1';
	  				end if;
	  				
	  				-- reg_enables
	  				if (addr_i(9 downto 6) >= "0000") then
	  					reg_en(iaddr) <= '1';
	  				end if;

	  			end if;
    		end if;
		end if;
  	end process;

	reg_en_o <= reg_en;
	ram_en_o <= ram_en;	


end rtl;
