-- hds header_start
--
-- VHDL Architecture CERC_FE_FPGA.dac_config.rtl
--
-- Created:
--          by - Osman Zorba.UNKNOWN (HEPPC185)
--          at - 18:05:48 09/30/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;

ENTITY dac_config IS
   PORT( 
      CLK40         : IN     std_logic;
      CONFIG_SELECT : IN     std_logic;
      reset         : IN     std_logic;
      SET_DATA      : IN     std_logic_vector (31 DOWNTO 0);
      DAC_DATA      : OUT    std_logic_vector (15 DOWNTO 0);
      LD_DAC_DATA   : OUT    std_logic;
      db_out        : OUT    std_logic_vector (31 DOWNTO 0);
      wr            : IN     std_logic;
      rd            : IN     std_logic
   );

-- Declarations

END dac_config ;

-- hds interface_end
ARCHITECTURE rtl OF dac_config IS

signal dac_data_int : std_logic_vector (15 downto 0);
signal ld_cnt  : std_logic_vector(7 downto 0);

BEGIN

config:process (CLK40)
begin

 if (CLK40'event and CLK40='0') then
    if(RESET='1') then
	  dac_data_int <= (others => '0');
      LD_DAC_DATA <='0';
	  db_out <= (others => 'Z');
	  ld_cnt <= (others => '0');

     elsif(CONFIG_SELECT = '1' and wr='1') then
            dac_data_int <= SET_DATA(15 downto 0);
            LD_DAC_DATA <='0';
	        ld_cnt <= (others => '0');

     elsif(CONFIG_SELECT = '1' and rd='1') then
	        db_out(15 downto 0) <= dac_data_int ;
			db_out(31 downto 16) <= (others => '0');

     elsif(CONFIG_SELECT = '0' or rd='0') then
	        db_out <= (others => 'Z') ;
			ld_cnt <= ld_cnt + 1;

			if(ld_cnt="00111111") then
              LD_DAC_DATA <='1';
			end if;

	 end if;
   end if;
  DAC_DATA <= dac_data_int;

end process config;
     
  
 
 
END rtl;
