-- hds header_start
--
-- VHDL Architecture CERC_FE_FPGA.dac_signals.rtl_dac_signals
--
-- Created:
--          by - Osman Zorba.UNKNOWN (HEPPC185)
--          at - 09:17:14 10/20/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;

ENTITY dac_signals IS
   PORT( 
      CLK1        : IN     std_logic;
      CLK40       : IN     std_logic;
      DAC_DATA    : IN     std_logic_vector (15 DOWNTO 0);
      LD_DAC_DATA : IN     std_logic;
      reset       : IN     std_logic;
      DAC_CLK     : OUT    std_logic;
      DAC_CS_B    : OUT    std_logic;
      DAC_DIN     : OUT    std_logic
   );

-- Declarations

END dac_signals ;

-- hds interface_end
ARCHITECTURE rtl_dac_signals OF dac_signals IS
signal shift_reg  : std_logic_vector(15 downto 0);
signal shift_cnt2  : std_logic_vector(5 downto 0);
signal cs_shift, clk_shift, dac_data_shift  : std_logic_vector(5 downto 0);
signal DAC_CS_B_int, SHIFT_EN, SHIFT_ENQ, ld_dacq, DAC_DIN_int : std_logic;

BEGIN

dac_data_sigs:process (CLK1)
 begin 

       if (CLK1'event and CLK1='1') then 
         if(reset='1') then
		   shift_reg <= (others => '0');
		   shift_cnt2 <= (others => '0');
		   SHIFT_EN <='0';
		   SHIFT_ENQ <='0';
		   ld_dacq <= '0';
		   DAC_CS_B_int <= '1';
		   

         else
		  
		   ld_dacq <= LD_DAC_DATA; 
		   SHIFT_EN <= SHIFT_ENQ ;

		   if (ld_dacq='0' and LD_DAC_DATA = '1') then
              shift_reg <= DAC_DATA; 
              DAC_CS_B_int <= '0';
              shift_cnt2 <= "000000";
			  SHIFT_ENQ <= '1';

           elsif (SHIFT_EN = '1') then 
		      if (shift_cnt2 < "001111") then
                  shift_cnt2 <= shift_cnt2 + 1;
                  DAC_CS_B_int <= '0';
                  shift_reg <= shift_reg(14 downto 0) & shift_reg(15);
             
               else
                 DAC_CS_B_int <= '1';
                 SHIFT_EN <= '0';

               end if;
			  	
		  end if;
		end if;
	  end if;
 end process dac_data_sigs;

 DAC_DIN_int <= shift_reg(15);



--  DAC CS Adjust
--
cs_delay:process(CLK40)
begin
   if(CLK40'event and CLK40='1') then
      cs_shift <= cs_shift(4 downto 0) & DAC_CS_B_int;
   end if;
end process cs_delay;

DAC_CS_B <= cs_shift(4);    -- works with cs_shift(1)  and   clk_shift(1)

--  DAC CLK Adjust
--
dac_clk_delay:process(CLK40)
begin
   if(CLK40'event and CLK40='1') then
     clk_shift <= clk_shift(4 downto 0) & CLK1;
   end if;
end process dac_clk_delay;

DAC_CLK <= clk_shift(0);

--  DAC DATA Adjust
--
dac_data_delay:process(CLK40)
begin
   if(CLK40'event and CLK40='1') then
     dac_data_shift <= dac_data_shift(4 downto 0) & DAC_DIN_int;
   end if;
end process dac_data_delay;

DAC_DIN <= dac_data_shift(2);



END rtl_dac_signals;
