-- hds header_start
--
-- VHDL Architecture CERC_FE_FPGA.src_id_reg.rtl_srcid
--
-- Created:
--          by - Osman Zorba.UNKNOWN (HEPPC185)
--          at - 12:30:15 10/11/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.ALL;

ENTITY src_id_reg IS
   PORT( 
      CLK40D      : IN     std_logic;
      CONV_END    : IN     std_logic;
      RESET       : IN     std_logic;
      SEL_SRCID   : IN     std_logic;
      fifo_count  : IN     std_logic_vector (9 DOWNTO 0);
      fifo_empty  : IN     std_logic;
      fifo_full   : IN     std_logic;
      src_id      : IN     std_logic_vector (2 DOWNTO 0);
      DATA_VALID8 : OUT    std_logic;
      DA_OUT      : OUT    std_logic_vector (31 DOWNTO 0)
   );

-- Declarations

END src_id_reg ;

-- hds interface_end
ARCHITECTURE rtl_srcid OF src_id_reg IS
signal tmp1: std_logic_vector (31 DOWNTO 0);
signal a, b, data_ready : std_logic;

BEGIN
process(CLK40D)

begin
 if (CLK40D'event and CLK40D='1') then

   if(RESET='1') then
      DA_OUT <= (others => 'Z');
	  tmp1 <= (others => '0');
	  a <= '0';
	  b <= '0';
	  data_ready <= '0';

   else
      a <= b;
      b <= CONV_END;

   if(a='0' and b='1') then
	    tmp1 (2 downto 0) <= src_id;
		tmp1 (17 downto 8) <= fifo_count;
		tmp1 (24) <= fifo_empty;
		tmp1 (25) <= fifo_full;
		tmp1 (31 downto 26) <= (others => '0') ;
 	    data_ready <= '1';

   end if;

   if(SEL_SRCID='1') then
        DA_OUT <= tmp1;

   else
        DA_OUT <=(others => 'Z');

   end if;

   if(a='1' and b='0') then
    data_ready <='0';
   end if;
  end if;

  DATA_VALID8 <= data_ready;

 end if;

  end process;

END rtl_srcid;
