-- hds header_start
--
-- VHDL Architecture CERC_FE_FPGA.tcalib_pulse_module.tcalib_rtl
--
-- Created:
--          by - Osman Zorba.UNKNOWN (HEPPC185)
--          at - 14:48:53 11/08/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

ENTITY tcalib_pulse_module IS
   PORT( 
      A0           : IN     std_logic;
      A1           : IN     std_logic;
      CLK160       : IN     std_logic;
      LD_CALDATA   : IN     std_logic;
      RESET        : IN     std_logic;
      TCALIB_WIDTH : IN     std_logic_vector (31 DOWNTO 0);
      TRIGIN       : IN     std_logic;
      rd           : IN     std_logic;
      wr           : IN     std_logic;
      TCALIB       : OUT    std_logic;
      db_out       : OUT    std_logic_vector (31 DOWNTO 0)
   );

-- Declarations

END tcalib_pulse_module ;

-- hds interface_end
ARCHITECTURE tcalib_rtl OF tcalib_pulse_module IS
signal tmpdelay, pulse_width : std_logic_vector(31 downto 0);
signal a, b, CAL_ENABLE_INT  : std_logic ;

BEGIN
TCALIB_PULSE0: process (CLK160)

begin

    if(CLK160'event and CLK160='1') then
      if(RESET = '1') then
        CAL_ENABLE_INT <= '1' ;
        tmpdelay <= (others => '0') ;
        db_out <= (others => 'Z') ;

       elsif (LD_CALDATA ='1'and A0 = '0' and A1 = '0' and wr='1') then 
           tmpdelay <= TCALIB_WIDTH ;

       elsif (LD_CALDATA ='1'and A0 = '1' and A1 = '0' and wr='1') then
           CAL_ENABLE_INT <= TCALIB_WIDTH(0) ;

       elsif (LD_CALDATA ='1'and A0 = '0' and A1 = '0' and rd='1') then 
           db_out <= tmpdelay ;

       elsif (LD_CALDATA ='1'and A0 = '1' and A1 = '0' and rd='1') then
           db_out(0) <= CAL_ENABLE_INT ;
           db_out(31 downto 1) <= (others => '0');

       elsif(LD_CALDATA = '0' or rd = '0') then 
           db_out <= (others => 'Z') ;

      end if;
   end if;
end process TCALIB_PULSE0;

TCALIB_PULSE: process (CLK160)
 
begin

    if(CLK160'event and CLK160='1') then
      if(RESET = '1') then
        TCALIB <= '0' ;
        pulse_width <= (others => '0') ;
 
       else
       a <= b ;
       b <= TRIGIN ;

 
      if (a='0' and b='1') then -- trigger detected
          pulse_width <= tmpdelay ;
      end if;

      if (pulse_width = "00000000000000000000000000000000") then
          TCALIB <= '0' ; 
	  elsif(CAL_ENABLE_INT = '1') then
          pulse_width <= pulse_width - 1 ;
          TCALIB <= '1' ;
      end if;
    end if; 
   end if;
      
end process TCALIB_PULSE;

END tcalib_rtl;
