-- hds header_start
--
-- VHDL Architecture CERC_FE_FPGA.tcalib_reg.rtl_reg
--
-- Created:
--          by - Osman Zorba.UNKNOWN (HEPPC185)
--          at - 15:30:12 11/08/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.all;
USE ieee.std_logic_unsigned.ALL;

ENTITY tcalib_reg IS
   PORT( 
      A0           : IN     std_logic;
      A1           : IN     std_logic;
      CLK40        : IN     std_logic;
      LD_CALDATA   : IN     std_logic;
      RESET        : IN     std_logic;
      SET_DATA_int : IN     std_logic_vector (31 DOWNTO 0);
      rd           : IN     std_logic;
      wr           : IN     std_logic;
      CAL_ENABLE   : OUT    std_logic;
      db_out       : OUT    std_logic_vector (31 DOWNTO 0);
      pulse_width  : OUT    std_logic_vector (31 DOWNTO 0)
   );

-- Declarations

END tcalib_reg ;

-- hds interface_end
ARCHITECTURE rtl_reg OF tcalib_reg IS
signal pulse_width_int : std_logic_vector(31 downto 0);
signal CAL_ENABLE_INT : std_logic;

BEGIN
TCALIB_PULSE0: process (CLK40)

begin

    if(CLK40'event and CLK40='0') then
      if(RESET = '1') then
        CAL_ENABLE_INT <= '1' ;
        pulse_width_int <= (others => '0') ;
        db_out <= (others => 'Z') ;

       elsif (LD_CALDATA ='1'and A0 = '0' and A1 = '0' and wr='1') then 
           pulse_width_int <= SET_DATA_int ;

       elsif (LD_CALDATA ='1'and A0 = '1' and A1 = '0' and wr='1') then
           CAL_ENABLE_INT <= SET_DATA_int(0) ;

       elsif (LD_CALDATA ='1'and A0 = '0' and A1 = '0' and rd='1') then 
           db_out <= pulse_width_int ;

       elsif (LD_CALDATA ='1'and A0 = '1' and A1 = '0' and rd='1') then
           db_out(0) <= CAL_ENABLE_INT ;
           db_out(31 downto 1) <= (others => '0');

       elsif(LD_CALDATA = '0' or rd = '0') then 
           db_out <= (others => 'Z') ;

      end if;
   end if;
end process TCALIB_PULSE0;

pulse_width <= pulse_width_int;
CAL_ENABLE <= CAL_ENABLE_INT;

END rtl_reg;
