-- hds header_start
--
-- VHDL Architecture CERC_FE_FPGA.trig_cnt_reg.rtl_trig_cnt
--
-- Created:
--          by - Osman Zorba.UNKNOWN (HEPPC185)
--          at - 12:52:01 10/21/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.ALL;

ENTITY trig_cnt_reg IS
   PORT( 
      CLK40D        : IN     std_logic;
      CONV_END      : IN     std_logic;
      RESET         : IN     std_logic;
      SEL_TRIG_DATA : IN     std_logic;
      trig_data_reg : IN     std_logic_vector (31 DOWNTO 0);
      DATA_VALID9   : OUT    std_logic;
      DA_OUT        : OUT    std_logic_vector (31 DOWNTO 0)
   );

-- Declarations

END trig_cnt_reg ;

-- hds interface_end
ARCHITECTURE rtl_trig_cnt OF trig_cnt_reg IS
signal tmp1: std_logic_vector (31 DOWNTO 0);
signal a, b, data_ready : std_logic;

BEGIN
process(CLK40D)

begin
 if (CLK40D'event and CLK40D='1') then

   if(RESET='1') then
      DA_OUT <= (others => 'Z');
	  tmp1 <= (others => '0');
	  a <= '0';
	  b <= '0';
	  data_ready <= '0';

   else
      a <= b;
      b <= CONV_END;

   if(a='0' and b='1') then
	    tmp1 <= trig_data_reg;
 	    data_ready <= '1';

   end if;

   if(SEL_TRIG_DATA='1') then
        DA_OUT <= trig_data_reg;

   else
        DA_OUT <=(others => 'Z');

   end if;

   if(a='1' and b='0') then
    data_ready <='0';
   end if;
  end if;

  DATA_VALID9 <= data_ready;

 end if;

  end process;

END rtl_trig_cnt;
